Improved hgeditor:
authorThomas Arendsen Hein <thomas@intevation.de>
Tue, 14 Jun 2005 08:49:52 +0100
changeset 348 442eb02cf87015019271160fc105a1e9694564f2
parent 347 a0b2758edee727fd30581665a52164659286df12
child 349 b2293093b89e176707a3250f3e861382a0578aff
push id1
push usergszorc@mozilla.com
push dateWed, 18 Mar 2015 16:34:57 +0000
Improved hgeditor: -----BEGIN PGP SIGNED MESSAGE----- Hash: SHA1 Improved hgeditor: hgeditor now uses $EDITOR and sets options according to emacs/vim/... Cleanup of temporary files. Use simple 'hg diff' instead of calling it for every file. Call gpg only if commit message was changed. manifest hash: 5c56bf580f9c2ef2a7d8b680bfb73fdd3b232044 -----BEGIN PGP SIGNATURE----- Version: GnuPG v1.4.1 (GNU/Linux) iD8DBQFCrowgW7P1GVgWeRoRApiOAJ0UI9/OY3yr4bv0no+KCcponSq+ZwCdFDUU No8t9ni6/72zmlcpB13E63A= =oSyb -----END PGP SIGNATURE-----
hgeditor
--- a/hgeditor
+++ b/hgeditor
@@ -1,21 +1,42 @@
 #!/bin/bash
 #
 # This is an example of using HGEDITOR to automate the signing of
 # commits and so on.
 
-MANIFEST=`grep '^HG: manifest hash' $1 | cut -b 19-`
-if grep -q "^HG: merge resolve" $1 ; then
+T1=""; T2=""
+cleanup_exit() {
+    rm -f "$T1" "$T2"
+    exit $1
+}
+
+case "${EDITOR:=vi}" in
+    emacs)
+        EDITOR="$EDITOR -nw"
+        ;;
+    gvim|vim)
+        EDITOR="$EDITOR -f -o"
+        ;;
+esac
+
+if grep -q "^HG: merge resolve" "$1" ; then
     # we don't sign merges
-    $EDITOR $1
+    exec $EDITOR "$1"
 else
-    T=`mktemp`
-    CHANGED=`grep '^HG: changed' $1 | cut -b 13-`
-    # show a diff so writing commit comments is easier
-    hg diff $CHANGED >> $T
-    echo -e "\n\nmanifest hash: $MANIFEST" > $1
-    emacs -nw $T $1 
-    head -1 $1 > $T
-    echo >> $T
-    gpg -a -u $HGUSER -o - --clearsign $1 >> $T
-    mv $T $1
+    T1=`mktemp`; T2=`mktemp`
+    MANIFEST=`grep '^HG: manifest hash' "$1" | cut -b 19-`
+
+    echo -e "\n\nmanifest hash: $MANIFEST" >> "$T1"
+    grep -vE '^(HG: manifest hash .*)?$' "$1" >> "$T1"
+    hg diff >> "$T2"
+
+    CHECKSUM=`md5sum "$T1"`
+    $EDITOR "$T1" "$T2" || cleanup_exit $?
+    echo "$CHECKSUM" | md5sum -c 2>/dev/null && cleanup_exit 0
+    {
+        head -1 "$T1"
+        echo
+        grep -v "^HG:" "$T1" | gpg -a -u "${HGUSER:-$EMAIL}" --clearsign
+    } > "$T2" && mv "$T2" "$1"
+    cleanup_exit $?
 fi
+